package com.danitheskunk.skunkworks;

import org.lwjgl.BufferUtils;

import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;

import static org.lwjgl.opengl.GL11.*;

class GLTextureAtlas {
	private Image img;
	private int textureID;
	private List<GLTexture> textures;

	GLTextureAtlas() {
		img = new Image(new Vec2i(32, 32));
		textureID = glGenTextures();
		textures = new ArrayList<>();

		glBindTexture(GL_TEXTURE_2D, textureID);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);

	}

	ITexture addTexture(Image img) {
		//todo: do the actual texture stuff
		this.img = img;
		update();
		var texture = new GLTexture(new Recti(new Vec2i(0, 0), img.getSize()));
		textures.add(texture);
		return texture;
	}

	void update() {
		var buf = BufferUtils.createByteBuffer(img.getData().length);
		buf.put(img.getData());
		buf.flip();

		glTexImage2D(
			GL_TEXTURE_2D,
			0,
			GL_RGBA,
			img.getWidth(),
			img.getHeight(),
			0,
			GL_RGBA,
			GL_UNSIGNED_BYTE,
			buf
		);
	}
}
